package core

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestComputeDBURL(t *testing.T) {
	LoadEnvVars("../../.env")

	dbHost := MustGetEnvVar("TEST_DB_HOST")
	dbPort := MustGetEnvVar("TEST_DB_PORT")
	dbUser := MustGetEnvVar("TEST_DB_USER")
	dbPassword := MustGetEnvVar("TEST_DB_PASSWORD")
	dbName := MustGetEnvVar("TEST_DB_NAME")

	dbURL := ComputeDBURL(dbHost, dbPort, dbUser, dbPassword, dbName)

	assert.Equal(t, dbURL, "postgres://dev:dev@host.docker.internal:5432/trepa_test")
}

func TestSetupDB(t *testing.T) {
	LoadEnvVars("../../.env")

	dbHost := MustGetEnvVar("TEST_DB_HOST")
	dbPort := MustGetEnvVar("TEST_DB_PORT")
	dbUser := MustGetEnvVar("TEST_DB_USER")
	dbPassword := MustGetEnvVar("TEST_DB_PASSWORD")
	dbName := MustGetEnvVar("TEST_DB_NAME")

	dbURL := ComputeDBURL(dbHost, dbPort, dbUser, dbPassword, dbName)
	db, err := SetupDB(dbURL)
	defer db.Close()

	assert.NoError(t, err)
	assert.NotNil(t, db)
}
